.!/bin/dash
# getjava
# jamesbond 2015
# MIT license
# adapted for tahrpup64

WORKDIR=/tmp/getjava/work.$$
#COMP_MODE="-comp lzo -Xcompression-level 1"
COMP_MODE="-comp xz -Xbcj x86"

setarch() {
	case $(uname -m) in
		x86_64)
			ARCH=x64
			LIBDIR=lib ;;
		i?86)
			ARCH=i586
			LIBDIR=lib ;;
		*) msg Unsupported architecture.
		   exit 1 ;;
	esac
}

# $@ - text
msg() {
	echo "$@"
}

get_latest_version() {
	msg "Finding latest available version ... "
	wget -4c http://www.oracle.com/technetwork/java/javase/downloads/
##grep -i "Version [0-9] Update [0-9]" index.html > /tmp/CURRENTVersion
grep -i "Java Platform (JDK) [0-9]u[0-9]" index.html > /tmp/CURRENTVersion

RegExStr="u[0-9][0-9]"
egrep -o $RegExStr "/tmp/CURRENTVersion" > /tmp/Cur_updateNo

while read p; do
CURRENTVersion=${p}
done </tmp/CURRENTVersion

 
 if [ ! "$CURRENTVersion" ];then 
      popup "name=bk2 background='#279CFA' placement=top-middle width=-1|<b>Internet isn't currently connected</b>"
echo "terminate=10 timecount=dn writemode=append-newline|Popup will terminate in <big><b><span color='#ff0000'>COUNT</span></b></big> seconds" >> /tmp/popup_bk2
      exit 1
     fi
 
#echo $CURRENTVersion
while read p; do
Cur_updateNo=${p}
done </tmp/Cur_updateNo
while read p; do
updateNo=$p
done </tmp/updateNo

RegExStr="[0-9][0-9]"
egrep -o $RegExStr "/tmp/Cur_updateNo" > /tmp/Cur_updateNo2

while read p; do
Cur_updateNo2=${p}
done </tmp/Cur_updateNo2



	LATEST=1.8.0_$Cur_updateNo2
	#LATEST=$(wget -qO - http://java.com/applet/JreCurrentVersion2.txt | tr -d '\r\n') # 1.8.0_31
	UPDATE=${LATEST#*_}
	JDKVER=${LATEST%.*}; JDKVER=${JDKVER#1.}
	VERSION=${JDKVER}u${UPDATE}
	msg Latest version is $VERSION
}

# $1-version
get_build() {
	msg "Finding latest build ... "
	# wget --no-check-certificate --no-cookies --header "Cookie: oraclelicense=accept-securebackup-cookie"
	# http://download.oracle.com/otn-pub/java/jdk/8u31-b13/jdk-8u31-linux-x64.tar.gz
	BUILD=""
	#for p in 13; do	
	for p in $(seq 40 -1 1); do
		msg "Check whether build $p is available ... "
		wget -qS --spider --no-check-certificate --no-cookies --header "Cookie: oraclelicense=accept-securebackup-cookie" \
		"http://download.oracle.com/otn-pub/java/jdk/$VERSION-b$p/jdk-$VERSION-linux-$ARCH.tar.gz" 2>&1 |
		grep -q "HTTP.*200 OK" && BUILD=$p && break
	done
	msg yes, will use this build $BUILD.
}

# $1-version
download() {
	msg "Downloading Java $VERSION build $BUILD ..."
	[ $BUILD ] || { msg Cannot find build number, exiting. ; exit; }
	wget -c --no-check-certificate --no-cookies --header "Cookie: oraclelicense=accept-securebackup-cookie" \
	"http://download.oracle.com/otn-pub/java/jdk/$VERSION-b$BUILD/jdk-$VERSION-linux-$ARCH.tar.gz"
}

makesfs() {
	cd $WORKDIR &&
	mkdir -p workroot &&
	(cd workroot; mkdir -p opt root/Choices/MIME-types usr/bin usr/$LIBDIR/mozilla/plugins usr/share/applications; ) &&
	
	tar -xf jdk-$VERSION-linux-$ARCH.tar.gz -C workroot &&
	mv workroot/jdk* workroot/opt/java-$VERSION &&
	
	ln -sf java-$VERSION workroot/opt/java &&
	ln -sf /opt/java/bin/java workroot/usr/bin/java &&
	ln -sf /opt/java/jre/lib/amd64/libnpjp2.so workroot/usr/$LIBDIR/mozilla/plugins/libnpjp2.so &&
	echo '#! /bin/sh' > workroot/root/Choices/MIME-types/application_x-jar
	echo 'exec  java -jar "$@"' >> workroot/root/Choices/MIME-types/application_x-jar
	echo '#! /bin/sh' > workroot/root/Choices/MIME-types/application_x-java-archive
	echo 'exec  java -jar "$@"' >> workroot/root/Choices/MIME-types/application_x-java-archive
	echo '#! /bin/sh' > workroot/root/Choices/MIME-types/application_x-java-jnlp-file
	echo 'exec  javaws "$@"' >> workroot/root/Choices/MIME-types/application_x-java-jnlp-file
	chmod a+x workroot/root/Choices/MIME-types/application_x-jar
	chmod a+x workroot/root/Choices/MIME-types/application_x-java-archive
	chmod a+x workroot/root/Choices/MIME-types/application_x-java-jnlp-file
	echo '[Desktop Entry]
Encoding=UTF-8
Version=1.0
Name=Java Control Panel
Comment=Java Control Panel
Exec=/opt/java/bin/jcontrol
Terminal=false
Type=Application
Icon=/opt/java/jre/lib/images/icons/sun-java.png
Categories=X-Setup-wizard;' > workroot/usr/share/applications/sun_java_control_panel.desktop
	mksquashfs workroot $HOME/java-jdk-$VERSION-$ARCH.sfs -noappend $COMP_MODE &&
	rm -r workroot
}

sfsload() {
	sfs_load $HOME/java-jdk-$VERSION-$ARCH.sfs
}

trap 'rm -r $WORKDIR; exit' INT HUP 0

### main
setarch
mkdir -p $WORKDIR; cd $WORKDIR
get_latest_version
get_build
download
makesfs
msg done
sfsload
